#!/usr/bin/perl
 
use strict;
use CGI qw(:standard);
use CGI::Carp;
use DBI;
use POSIX;
#use_named_parameters(1);

my ($db, $host, $user, $pass, $tttname, $template, $dbh, $tttdate, $version);
my $output = new CGI;
$user = param('user') or $user = "timetool";
$pass = param('pass') or $pass = "webevent";
$db = param('db') or $db = "timetrack";
$host = param('host') or $host = "localhost";
$tttname = param('tttname') or $tttname = "defaultuser";
$dbh = DBI->connect("DBI:mysql:$db:$host", "$user", "$pass");
$tttdate = strftime("%Y-%m-%d", localtime);
## Just in case they screw up, give 'em my template...
if (-e $template) { $template = $template; } else {
	$template = "/var/www/html/template.html"; }


################
### Probably shouldn't mess with anything from here on down... 8)
################
$version = '0.96';
&main_menu if not param('action');
for (param('action')) {
 #Procedures to create/modify users and preferences   
   $_ eq 'user' and do { &user; last; };              	
   $_ eq 'user_entry' and do { &user_entry; last; };
 #Procedures to create user entries
   $_ eq 'add' and do { &add; last; };
   $_ eq 'add_entry' and do { &add_entry; last; };
 #Procedures to delete user entries   
   $_ eq 'delete' and do { &delete; last; };
   $_ eq 'delete_entry' and do { &delete_entry; last; };
 #Procedures to print reports and view data 
   $_ eq 'report' and do { &report; last; };
}

sub add {
   my $out = $dbh->prepare("select * from users where ttt_user='$tttname'");
   $out->execute;
   my $keysref = $out->fetchrow_hashref; 
   my %keys = %$keysref;
   my $template = $keys{'ttt_template'};
   print header, start_html('title'=>'Time Tracking Tool - Create Timesheet','BGCOLOR'=>'white');   

## Load Template File
 my $formattedhtml = '';
 open  (TEMPLATE, $template);
 while (<TEMPLATE>) { 
	$formattedhtml .= $_; 
 }
 close (TEMPLATE);
print <<HTML;
<h2>Current User: $tttname</h2> (using template: <b>$template</b>)
<FORM NAME="ttt" METHOD=POST ACTION="timetool.cgi">
<INPUT TYPE=HIDDEN NAME="action" VALUE="add_entry">
HTML
print ($formattedhtml);
print <<HTML;
<INPUT TYPE=HIDDEN NAME="tttname" VALUE="$tttname">
<TD WIDTH=123 BGCOLOR="#ffffff">
<P ALIGN=LEFT STYLE="font-style: normal; font-weight: medium; text-decoration: none">
<INPUT TYPE=TEXT NAME="ttt_date" VALUE="$tttdate" SIZE=16><BR></P></TD></TR></TBODY></TABLE>
<P STYLE="margin-bottom: 0in">
<INPUT TYPE=SUBMIT VALUE="Submit"><INPUT TYPE=RESET VALUE="Clear"></P>
<SCRIPT>
<!-- //Populate startup data
loadElements(document.forms[0].ttt_category.selectedIndex)
// -->
</SCRIPT>
<p><A HREF="timetool.cgi?tttname=$tttname">Return</a> to the main menu.</p>
</FORM></BODY></HTML>
HTML
}

sub report {
   print header, start_html('title'=>'Time Tracking Tool - Timesheet Report','BGCOLOR'=>'white');
   &showinfo(0);  ### don't show the id in the report...
print <<HTML;
<p><A HREF="timetool.cgi?tttname=$tttname">Return</a> to the Main Menu.
HTML
}

sub showinfo {
   my ($showid) = @_;
   my $bgcolor = "#CCCCBB"; ### set default background color
   my $out = $dbh->prepare("select * from timedata where ttt_user='$tttname' order by ttt_date DESC");
   $out->execute;
   print '<TABLE BORDER COLS=9 WIDTH="95%" border="4"><TR>';
   if ($showid) { print "<td bgcolor=",$bgcolor,">ID #</td>"; }
   print "<td font=bold bgcolor=",$bgcolor,">Project</td><td bgcolor=",$bgcolor,">Feature</td><td bgcolor=",$bgcolor,">Category</td><td bgcolor=",$bgcolor,">Activity</td><td bgcolor=",$bgcolor,">Description</td><td bgcolor=",$bgcolor,">Duration</td><td bgcolor=",$bgcolor,">Date</td></tr>";
   while(my $keysref = $out->fetchrow_hashref) {
      my %keys = %$keysref;
      print '<TR>';
      if ($keys{'ttt_date'} eq $tttdate) { $bgcolor = "#FFFFEE"; } else { $bgcolor = "#FFFFFF"; }
      if ($showid) { print '<TD bgcolor=',$bgcolor,' width="10%">',$keys{'ttt_id'},"</TD>"; }
      print '<TD bgcolor=',$bgcolor,' width="10%">',$keys{'ttt_project'},"</TD>";
      print '<TD bgcolor=',$bgcolor,' width="10%">',$keys{'ttt_feature'},"</TD>";
      print '<TD bgcolor=',$bgcolor,' width="10%">',$keys{'ttt_category'},"</TD>";
      print '<TD bgcolor=',$bgcolor,' width="10%">',$keys{'ttt_activity'},"</TD>";
      print '<TD bgcolor=',$bgcolor,' width="25%">',$keys{'ttt_description'},"</TD>";
      print '<TD bgcolor=',$bgcolor,' width="10%">',$keys{'ttt_duration'},"</TD>";
      print '<TD bgcolor=',$bgcolor,' width="10%">',$keys{'ttt_date'},"</TD></TR>"; 
   }
   print "</TABLE>";
}

sub delete {
   print header, start_html('title'=>'Time Tracking Tool - Delete Report','BGCOLOR'=>'white');
print <<HTML;
<FORM METHOD=POST ACTION="timetool.cgi">
<INPUT TYPE=HIDDEN NAME="action" VALUE="delete_entry">
<INPUT TYPE=HIDDEN NAME="tttname" VALUE=$tttname>
Enter id # to delete: <INPUT TYPE=TEXT NAME=ttt_id>
<INPUT TYPE=SUBMIT VALUE="Delete"><BR>
<i>*Note: The record will only be deleted if you own it.</i><HR>
HTML
&showinfo(1); ### show the id in the delete report...
print <<HTML;
<p><A HREF="timetool.cgi?tttname=$tttname">Return</a> to the main menu.</p>
</FORM></BODY></HTML>
HTML
}

sub delete_entry {
   my $id_delete = param('ttt_id');
   my $query = $dbh->prepare("delete from timedata where ttt_id=$id_delete and ttt_user='$tttname'");
   $query->execute;
print header, start_html('title'=>'Timesheet Deleted','BGCOLOR'=>'white');
print <<HTML;
<H1>Timesheet with ID# $id_delete Deleted</h1>
<p>Your information has been successfully deleted from the database.
<p>
<FORM><INPUT TYPE=HIDDEN NAME="tttname" VALUE=$tttname></FORM>
<A HREF="timetool.cgi?action=delete&tttname=$tttname">Delete</a> another Timesheet entry.<br><br>
<A HREF="timetool.cgi?tttname=$tttname">Return</a> to the main menu.
<p>
</body></html>
HTML
}

sub add_entry {
   my (%fields);
   foreach ('ttt_user','ttt_project', 'ttt_feature', 'ttt_category', 'ttt_activity', 'ttt_description', 'ttt_duration', 'ttt_date') {
      if (param($_)) { $fields{$_} = $dbh->quote(param($_)); }
      else { $fields{$_} = "''"; }
   }
   my $query = $dbh->prepare("insert into timedata (ttt_id, ttt_user, ttt_project, ttt_feature, ttt_category, ttt_activity, ttt_description, ttt_duration, ttt_date) values ('', '$tttname', $fields{'ttt_project'}, $fields{'ttt_feature'}, $fields{'ttt_category'}, $fields{'ttt_activity'}, $fields{'ttt_description'},$fields{'ttt_duration'}, $fields{'ttt_date'})");
   $query->execute;
   
print header, start_html('title'=>'Timesheet Added','BGCOLOR'=>'white');
print <<HTML;
<H1>Timesheet Added</h1>
<p>Your information has been successfully committed to the database.
<p>
<A HREF="timetool.cgi?tttname=$tttname">Return</a> to the main menu.<br>
<FORM><INPUT TYPE=HIDDEN NAME="tttname" VALUE=$tttname></FORM>
<p>
</body></html>
HTML
}

sub main_menu {
   print header, start_html('title'=>'Time Tracking Tool - Main Menu', 'BGCOLOR'=>'white');
   print <<HTML; 

<table align=left border=1 width="35%"><tr>
<td align=left bgcolor=#CCCCBB width="70%"><CENTER><H1>Time Tracking Tool<BR>Main Menu</h1><h4>Version $version</h4></CENTER></td></tr>

<tr><td bgcolor=#FFFFEF><CENTER>
<FORM ACTION="timetool.cgi" METHOD=POST>
<p>Please select your username: <SELECT NAME="tttname">
HTML
   my $out = $dbh->prepare("select * from users order by ttt_user");
   $out->execute;
   while(my $keysref = $out->fetchrow_hashref) {
      my %keys = %$keysref;
      print qq%<OPTION VALUE="$keys{'ttt_user'}"%;
      if ($keys{'ttt_user'} eq $tttname) { print ' SELECTED'; }
      print qq%>$keys{'ttt_user'}%;
   }
print <<HTML;
</select></CENTER><br>
&nbsp;&nbsp;Choose your action:<P> 
&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="radio" NAME="action" VALUE="add">&nbsp;&nbsp;Create a Timesheet Entry<br>
&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="radio" NAME="action" VALUE="delete">&nbsp;&nbsp;Delete a Timesheet Entry<br>
&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="radio" NAME="action" VALUE="report">&nbsp;&nbsp;View your Timesheet Report<P>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE=SUBMIT VALUE="  Submit  "><p><BR><BR>
<center><font size=-2>Written by Sebastian Barthelmess</font></center>
</form></body>
</TD></TR></TABLE>
</html>
HTML
}
